sns_conta/WebUI/webUI.SICO/Controllers/VoucherTypeController.cs
using System;
using System.Collections.Generic;
using System.Web.Mvc;
using webUI.SICO.Models;

namespace webUI.SICO.Controllers
{
    public class VoucherTypeController : Controller
    {
        // GET: VoucherType
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult List()
        {
            var result = new List<CatalogStringViewModel>();
            var voucherTypes = new businessLogic.Core.VoucherType().GetAll("");
            foreach (var vt in voucherTypes)
            {
                result.Add(new CatalogStringViewModel(vt.VoucherTypeId, vt.VoucherTypeName));
            }
            return View(result);
        }

        [HttpGet]
        public JsonResult GetVoucherTypes()
        {
            var viewData = new VoucherTypeListViewModel();
            var result = new List<CatalogStringViewModel>();
            try
            {
                var voucherTypes = new businessLogic.Core.VoucherType().GetAll("");
                foreach (var vt in voucherTypes)
                {
                    result.Add(new CatalogStringViewModel(vt.VoucherTypeId, vt.VoucherTypeName));
                }
                viewData.Info = result.ToArray();
            }
            catch (Exception ex)
            {
                viewData.Type = 'E';
                viewData.Message = ex.Message;
                viewData.Id = "404";
            }
            return Json(viewData, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Save(CatalogStringViewModel param)
        {

            ResponseModel result = new ResponseModel();
            try
            {
                var data = new businessLogic.Core.VoucherType(param.Code, param.Value, true);
                var response = data.Add(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Delete(CatalogStringViewModel param)
        {

            ResponseModel result = new ResponseModel();
            try
            {
                var data = new businessLogic.Core.VoucherType(param.Code, "", true);
                var response = data.Remove(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Edit(CatalogStringViewModel param)
        {
            ResponseModel result = new ResponseModel();
            try
            {
                var data = new businessLogic.Core.VoucherType(param.Code, param.Value, true);
                var response = data.Update(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


    }
}

sns_conta/WebUI/webUI.SICO/Views/VoucherType/List.cshtml
@model IEnumerable<webUI.SICO.Models.CatalogStringViewModel>

@{
    ViewBag.Title = "Tipo de Comprobantes";
}



<div class="row">
    <div class="col-md-12">
        <section class="block">
            <div class="block-header">
                <h3 class="block-title">@ViewBag.Title</h3>
                <div class="block-options">
                    <a href="../Home/Index/" class="btn btn-sm btn-secondary"><span class="fa fa-arrow-left"></span> Atr&aacute;s...</a>
                    <button type="button" class="btn btn-sm btn-success" data-toggle="modal" data-target="#CreateModal"><span class="fa fa-plus"></span> Nuevo</button>
                    <button type="button" class="btn-block-option" data-toggle="block-option" data-action="content_toggle"></button>
                    <!--<button type="button" class="btn-block-option" data-toggle="block-option" data-action="close">
                        <i class="si si-close"></i>
                    </button>-->
                </div>
            </div>
            <div class="block-content">
                <div class="table-responsive">
                    <table id="tbAccounts" class="table table-bordered table-striped table-vcenter">
                        <thead>
                            <tr>
                                <th width="25%">
                                    C&oacute;digo
                                </th>
                                <th width="65%">
                                    Descripci&oacute;n
                                </th>
                                <th width="100px"> Opciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Code)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Value)
                                    </td>
                                    <td>
                                        <span class="btn-group">
                                            <button class="btn btn-sm btn-primary" title="Editar" type="button" data-toggle="modal" data-target="#EditModal" onclick="fnLoadEdit('@item.Code','@item.Value')">
                                                <span class="fa fa-fw fa-pencil"></span>
                                            </button>
                                            <button class="btn btn-sm btn-primary" title="Eliminar" type="button" onclick="fnDelete('@item.Code')">
                                                <span class="fa fa-fw fa-times"></span>
                                            </button>
                                        </span>
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>


                </div>
                    

            </div>

</section>
    </div>
</div>


<!--==========================================================CREAR=============================================================-->

<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="CreateModal" class="modal fade">
    <div class="modal-dialog modal-dialog-popout" role="document">
        <div class="modal-content">
            <div class="block block-themed block-transparent mb-0">
                <div class="block-header bg-primary-dark">
                    <h3 class="block-title">Crear @ViewBag.Title</h3>
                    <div class="block-options">
                        <button type="button" class="btn-block-option" data-dismiss="modal" aria-label="Close">
                            <i class="fa fa-fw fa-times"></i>
                        </button>
                    </div>
                </div>
            </div>
            <div class="block-content font-size-sm">
                <div class="form-group">

                    <div class="form-group">
                        <label for="txtCode">C&oacute;digo:</label>
                        <input type="text" class="form-control" id="txtCode" placeholder="C&oacute;digo">
                    </div>

                    <div class="form-group">
                        <label for="txtValue">Valor:</label>
                        <input type="text" class="form-control" id="txtValue" placeholder="Valor">
                    </div>                    
                </div>

            </div>
            <div class="block-content block-content-full text-right border-top">
                <button id="btnEditSave" type="button" class="btn btn-sm btn-success" onclick="fnSave()"><i class="fa fa-check mr-1"></i>Guardar</button>
            </div>  
        </div>
    </div>
</div>

<!--==========================================================MODIFICAR=============================================================-->
<div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="EditModal" class="modal fade">
        <div class="modal-dialog modal-dialog-popout" role="document">
            <div class="modal-content">
                <div class="block block-themed block-transparent mb-0">
                    <div class="block-header bg-primary-dark">
                        <h3 class="block-title">Editar @ViewBag.Title</h3>
                        <div class="block-options">
                            <button type="button" class="btn-block-option" data-dismiss="modal" aria-label="Close">
                                <i class="fa fa-fw fa-times"></i>
                            </button>
                        </div>
                    </div>
                    <div class="block-content font-size-sm">
                        <div class="form-group">

                            <div class="form-group">
                                <label for="txtEditCode">C&oacute;digo:</label>
                                <input type="text" class="form-control" id="txtEditCode" placeholder="C&oacute;digo" disabled>
                            </div>

                            <div class="form-group">
                                <label for="txtEditValue">Valor:</label>
                                <input type="text" class="form-control" id="txtEditValue" placeholder="Valor">
                            </div>

                                                        
                        </div>

                    </div>
                    <div class="block-content block-content-full text-right border-top">                        
                        <button id="btnEditSave" type="button" class="btn btn-sm btn-success" onclick="fnEdit()"><i class="fa fa-check mr-1"></i>Guardar</button>
                    </div>

                    <!--<small class="font-bold">Seleccione uno de los proveedores del resultado.</small>-->
                </div>                    
            </div>
        </div>
    </div>



    @section Scripts {
        <script type="text/javascript">

        function fnLoadEdit(id, name)        {
            $("#txtEditCode").val(id);
            $("#txtEditValue").val(name);
        }

        function fnSave()
        {

            var par = {};
            par.Code = $("#txtCode").val();
            par.Value = $("#txtValue").val();

            $.ajax({
              url: ('@Url.Action("Save", "VoucherType")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message, "Error", { closeButton: true });
                      $("#CreateModal").modal('hide');
                  }
                  else {
                      toastr.success('Se guardo correctamente.', 'Exitoso', { closeButton: true });
                      $("#txtValue").prop('disabled', true);
                      $("#btnSave").prop('disabled', true);

                      fnRecargar();
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error', { closeButton: true });
              }
            });
        }

        function fnDelete(id)
        {

            var par = {};
            par.Code = id;


            $.ajax({
              url: ('@Url.Action("Delete", "VoucherType")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message, 'Error', { closeButton: true });
                      fnRecargar();
                  }
                  else {
                      toastr.success('Se elimino correctamente.', 'Exitoso', { closeButton: true });
                      fnRecargar();
                  }
              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error', { closeButton: true });
              }
            });
        }

        function fnEdit()
        {

            var par = {};
            par.Code = $("#txtEditCode").val();;
            par.Value = $("#txtEditValue").val();

            $.ajax({
              url: ('@Url.Action("Edit", "VoucherType")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message, 'Error', { closeButton: true });
                      $("#EditModal").modal('hide');
                  }
                  else {
                      toastr.success('Se guardo correctamente.', 'Exitoso', { closeButton: true });
                      $("#txtEditValue").prop('disabled', true);
                      $("#btnEditSave").prop('disabled', true);

                      fnRecargar();
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error', { closeButton: true });
              }
            });
        }



         function fnRecargar()
         {
             location.reload(true);
         }


        </script>

        @Scripts.Render("~/bundles/jqueryval")
    }